#ifndef _IA64REG_
#define _IA64REG_
#if _MSC_VER > 1000
#pragma once
#endif


typedef enum IA64_REG_INDEX {              // Intel-IA64-Filler

    //
    // Register set for Intel IA64              // Intel-IA64-Filler
    //


    // Branch Registers              // Intel-IA64-Filler

    CV_IA64_BrRp     =   512,              // Intel-IA64-Filler
    CV_IA64_BrS0     =   513,              // Intel-IA64-Filler
    CV_IA64_BrS1     =   514,              // Intel-IA64-Filler
    CV_IA64_BrS2     =   515,              // Intel-IA64-Filler
    CV_IA64_BrS3     =   516,              // Intel-IA64-Filler
    CV_IA64_BrS4     =   517,              // Intel-IA64-Filler
    CV_IA64_BrT0     =   518,              // Intel-IA64-Filler
    CV_IA64_BrT1     =   519,              // Intel-IA64-Filler

    // Predicate Registers              // Intel-IA64-Filler

    CV_IA64_Preds     =   768,              // Intel-IA64-Filler

    // Banked General Registers              // Intel-IA64-Filler

    CV_IA64_IntH0    =   832,              // Intel-IA64-Filler
    CV_IA64_IntH1    =   833,              // Intel-IA64-Filler
    CV_IA64_IntH2    =   834,              // Intel-IA64-Filler
    CV_IA64_IntH3    =   835,              // Intel-IA64-Filler
    CV_IA64_IntH4    =   836,              // Intel-IA64-Filler
    CV_IA64_IntH5    =   837,              // Intel-IA64-Filler
    CV_IA64_IntH6    =   838,              // Intel-IA64-Filler
    CV_IA64_IntH7    =   839,              // Intel-IA64-Filler
    CV_IA64_IntH8    =   840,              // Intel-IA64-Filler
    CV_IA64_IntH9    =   841,              // Intel-IA64-Filler
    CV_IA64_IntH10    =   842,              // Intel-IA64-Filler
    CV_IA64_IntH11    =   843,              // Intel-IA64-Filler
    CV_IA64_IntH12    =   844,              // Intel-IA64-Filler
    CV_IA64_IntH13    =   845,              // Intel-IA64-Filler
    CV_IA64_IntH14    =   846,              // Intel-IA64-Filler
    CV_IA64_IntH15    =   847,              // Intel-IA64-Filler

    // Special Registers              // Intel-IA64-Filler

    CV_IA64_Ip     =   1016,              // Intel-IA64-Filler
    CV_IA64_Umask  =   1017,              // Intel-IA64-Filler
    CV_IA64_Cfm    =   1018,              // Intel-IA64-Filler
    CV_IA64_Psr    =   1019,              // Intel-IA64-Filler

    // Banked General Registers              // Intel-IA64-Filler

    CV_IA64_Nats     =   1020,              // Intel-IA64-Filler
    CV_IA64_Nats2    =   1021,              // Intel-IA64-Filler
    CV_IA64_Nats3    =   1022,              // Intel-IA64-Filler

    // General-Purpose Registers              // Intel-IA64-Filler

    // INTEGER REGISTER              // Intel-IA64-Filler
    CV_IA64_IntZero  =   1024,              // Intel-IA64-Filler
    CV_IA64_IntGp    =   1025,              // Intel-IA64-Filler
    CV_IA64_IntT0    =   1026,              // Intel-IA64-Filler
    CV_IA64_IntT1    =   1027,              // Intel-IA64-Filler
    CV_IA64_IntS0    =   1028,              // Intel-IA64-Filler
    CV_IA64_IntS1    =   1029,              // Intel-IA64-Filler
    CV_IA64_IntS2    =   1030,              // Intel-IA64-Filler
    CV_IA64_IntS3    =   1031,              // Intel-IA64-Filler
    CV_IA64_IntV0    =   1032,              // Intel-IA64-Filler
    CV_IA64_IntAp    =   1033,              // Intel-IA64-Filler
    CV_IA64_IntT2    =   1034,              // Intel-IA64-Filler
    CV_IA64_IntT3    =   1035,              // Intel-IA64-Filler
    CV_IA64_IntSp    =   1036,              // Intel-IA64-Filler
    CV_IA64_IntT4    =   1037,              // Intel-IA64-Filler
    CV_IA64_IntT5    =   1038,              // Intel-IA64-Filler
    CV_IA64_IntT6    =   1039,              // Intel-IA64-Filler
    CV_IA64_IntT7    =   1040,              // Intel-IA64-Filler
    CV_IA64_IntT8    =   1041,              // Intel-IA64-Filler
    CV_IA64_IntT9    =   1042,              // Intel-IA64-Filler
    CV_IA64_IntT10   =   1043,              // Intel-IA64-Filler
    CV_IA64_IntT11   =   1044,              // Intel-IA64-Filler
    CV_IA64_IntT12   =   1045,              // Intel-IA64-Filler
    CV_IA64_IntT13   =   1046,              // Intel-IA64-Filler
    CV_IA64_IntT14   =   1047,              // Intel-IA64-Filler
    CV_IA64_IntT15   =   1048,              // Intel-IA64-Filler
    CV_IA64_IntT16   =   1049,              // Intel-IA64-Filler
    CV_IA64_IntT17   =   1050,              // Intel-IA64-Filler
    CV_IA64_IntT18   =   1051,              // Intel-IA64-Filler
    CV_IA64_IntT19   =   1052,              // Intel-IA64-Filler
    CV_IA64_IntT20   =   1053,              // Intel-IA64-Filler
    CV_IA64_IntT21   =   1054,              // Intel-IA64-Filler
    CV_IA64_IntT22   =   1055,              // Intel-IA64-Filler

    // Register Stack              // Intel-IA64-Filler
    CV_IA64_IntR32   =   1056,              // Intel-IA64-Filler
    CV_IA64_IntR33   =   1057,              // Intel-IA64-Filler
    CV_IA64_IntR34   =   1058,              // Intel-IA64-Filler
    CV_IA64_IntR35   =   1059,              // Intel-IA64-Filler
    CV_IA64_IntR36   =   1060,              // Intel-IA64-Filler
    CV_IA64_IntR37   =   1061,              // Intel-IA64-Filler
    CV_IA64_IntR38   =   1062,              // Intel-IA64-Filler
    CV_IA64_IntR39   =   1063,              // Intel-IA64-Filler
    CV_IA64_IntR40   =   1064,              // Intel-IA64-Filler
    CV_IA64_IntR41   =   1065,              // Intel-IA64-Filler
    CV_IA64_IntR42   =   1066,              // Intel-IA64-Filler
    CV_IA64_IntR43   =   1067,              // Intel-IA64-Filler
    CV_IA64_IntR44   =   1068,              // Intel-IA64-Filler
    CV_IA64_IntR45   =   1069,              // Intel-IA64-Filler
    CV_IA64_IntR46   =   1070,              // Intel-IA64-Filler
    CV_IA64_IntR47   =   1071,              // Intel-IA64-Filler
    CV_IA64_IntR48   =   1072,              // Intel-IA64-Filler
    CV_IA64_IntR49   =   1073,              // Intel-IA64-Filler
    CV_IA64_IntR50   =   1074,              // Intel-IA64-Filler
    CV_IA64_IntR51   =   1075,              // Intel-IA64-Filler
    CV_IA64_IntR52   =   1076,              // Intel-IA64-Filler
    CV_IA64_IntR53   =   1077,              // Intel-IA64-Filler
    CV_IA64_IntR54   =   1078,              // Intel-IA64-Filler
    CV_IA64_IntR55   =   1079,              // Intel-IA64-Filler
    CV_IA64_IntR56   =   1080,              // Intel-IA64-Filler
    CV_IA64_IntR57   =   1081,              // Intel-IA64-Filler
    CV_IA64_IntR58   =   1082,              // Intel-IA64-Filler
    CV_IA64_IntR59   =   1083,              // Intel-IA64-Filler
    CV_IA64_IntR60   =   1084,              // Intel-IA64-Filler
    CV_IA64_IntR61   =   1085,              // Intel-IA64-Filler
    CV_IA64_IntR62   =   1086,              // Intel-IA64-Filler
    CV_IA64_IntR63   =   1087,              // Intel-IA64-Filler
    CV_IA64_IntR64   =   1088,              // Intel-IA64-Filler
    CV_IA64_IntR65   =   1089,              // Intel-IA64-Filler
    CV_IA64_IntR66   =   1090,              // Intel-IA64-Filler
    CV_IA64_IntR67   =   1091,              // Intel-IA64-Filler
    CV_IA64_IntR68   =   1092,              // Intel-IA64-Filler
    CV_IA64_IntR69   =   1093,              // Intel-IA64-Filler
    CV_IA64_IntR70   =   1094,              // Intel-IA64-Filler
    CV_IA64_IntR71   =   1095,              // Intel-IA64-Filler
    CV_IA64_IntR72   =   1096,              // Intel-IA64-Filler
    CV_IA64_IntR73   =   1097,              // Intel-IA64-Filler
    CV_IA64_IntR74   =   1098,              // Intel-IA64-Filler
    CV_IA64_IntR75   =   1099,              // Intel-IA64-Filler
    CV_IA64_IntR76   =   1100,              // Intel-IA64-Filler
    CV_IA64_IntR77   =   1101,              // Intel-IA64-Filler
    CV_IA64_IntR78   =   1102,              // Intel-IA64-Filler
    CV_IA64_IntR79   =   1103,              // Intel-IA64-Filler
    CV_IA64_IntR80   =   1104,              // Intel-IA64-Filler
    CV_IA64_IntR81   =   1105,              // Intel-IA64-Filler
    CV_IA64_IntR82   =   1106,              // Intel-IA64-Filler
    CV_IA64_IntR83   =   1107,              // Intel-IA64-Filler
    CV_IA64_IntR84   =   1108,              // Intel-IA64-Filler
    CV_IA64_IntR85   =   1109,              // Intel-IA64-Filler
    CV_IA64_IntR86   =   1110,              // Intel-IA64-Filler
    CV_IA64_IntR87   =   1111,              // Intel-IA64-Filler
    CV_IA64_IntR88   =   1112,              // Intel-IA64-Filler
    CV_IA64_IntR89   =   1113,              // Intel-IA64-Filler
    CV_IA64_IntR90   =   1114,              // Intel-IA64-Filler
    CV_IA64_IntR91   =   1115,              // Intel-IA64-Filler
    CV_IA64_IntR92   =   1116,              // Intel-IA64-Filler
    CV_IA64_IntR93   =   1117,              // Intel-IA64-Filler
    CV_IA64_IntR94   =   1118,              // Intel-IA64-Filler
    CV_IA64_IntR95   =   1119,              // Intel-IA64-Filler
    CV_IA64_IntR96   =   1120,              // Intel-IA64-Filler
    CV_IA64_IntR97   =   1121,              // Intel-IA64-Filler
    CV_IA64_IntR98   =   1122,              // Intel-IA64-Filler
    CV_IA64_IntR99   =   1123,              // Intel-IA64-Filler
    CV_IA64_IntR100   =   1124,              // Intel-IA64-Filler
    CV_IA64_IntR101   =   1125,              // Intel-IA64-Filler
    CV_IA64_IntR102   =   1126,              // Intel-IA64-Filler
    CV_IA64_IntR103   =   1127,              // Intel-IA64-Filler
    CV_IA64_IntR104   =   1128,              // Intel-IA64-Filler
    CV_IA64_IntR105   =   1129,              // Intel-IA64-Filler
    CV_IA64_IntR106   =   1130,              // Intel-IA64-Filler
    CV_IA64_IntR107   =   1131,              // Intel-IA64-Filler
    CV_IA64_IntR108   =   1132,              // Intel-IA64-Filler
    CV_IA64_IntR109   =   1133,              // Intel-IA64-Filler
    CV_IA64_IntR110   =   1134,              // Intel-IA64-Filler
    CV_IA64_IntR111   =   1135,              // Intel-IA64-Filler
    CV_IA64_IntR112   =   1136,              // Intel-IA64-Filler
    CV_IA64_IntR113   =   1137,              // Intel-IA64-Filler
    CV_IA64_IntR114   =   1138,              // Intel-IA64-Filler
    CV_IA64_IntR115   =   1139,              // Intel-IA64-Filler
    CV_IA64_IntR116   =   1140,              // Intel-IA64-Filler
    CV_IA64_IntR117   =   1141,              // Intel-IA64-Filler
    CV_IA64_IntR118   =   1142,              // Intel-IA64-Filler
    CV_IA64_IntR119   =   1143,              // Intel-IA64-Filler
    CV_IA64_IntR120   =   1144,              // Intel-IA64-Filler
    CV_IA64_IntR121   =   1145,              // Intel-IA64-Filler
    CV_IA64_IntR122   =   1146,              // Intel-IA64-Filler
    CV_IA64_IntR123   =   1147,              // Intel-IA64-Filler
    CV_IA64_IntR124   =   1148,              // Intel-IA64-Filler
    CV_IA64_IntR125   =   1149,              // Intel-IA64-Filler
    CV_IA64_IntR126   =   1150,              // Intel-IA64-Filler
    CV_IA64_IntR127   =   1151,              // Intel-IA64-Filler

    // Floating-Point Registers              // Intel-IA64-Filler

    // Low Floating Point Registers              // Intel-IA64-Filler
    CV_IA64_FltZero  =   2048,              // Intel-IA64-Filler
    CV_IA64_FltOne   =   2049,              // Intel-IA64-Filler
    CV_IA64_FltS0    =   2050,              // Intel-IA64-Filler
    CV_IA64_FltS1    =   2051,              // Intel-IA64-Filler
    CV_IA64_FltS2    =   2052,              // Intel-IA64-Filler
    CV_IA64_FltS3    =   2053,              // Intel-IA64-Filler
    CV_IA64_FltT0    =   2054,              // Intel-IA64-Filler
    CV_IA64_FltT1    =   2055,              // Intel-IA64-Filler
    CV_IA64_FltT2    =   2056,              // Intel-IA64-Filler
    CV_IA64_FltT3    =   2057,              // Intel-IA64-Filler
    CV_IA64_FltT4    =   2058,              // Intel-IA64-Filler
    CV_IA64_FltT5    =   2059,              // Intel-IA64-Filler
    CV_IA64_FltT6    =   2060,              // Intel-IA64-Filler
    CV_IA64_FltT7    =   2061,              // Intel-IA64-Filler
    CV_IA64_FltT8    =   2062,              // Intel-IA64-Filler
    CV_IA64_FltT9    =   2063,              // Intel-IA64-Filler
    CV_IA64_FltS4    =   2064,              // Intel-IA64-Filler
    CV_IA64_FltS5    =   2065,              // Intel-IA64-Filler
    CV_IA64_FltS6    =   2066,              // Intel-IA64-Filler
    CV_IA64_FltS7    =   2067,              // Intel-IA64-Filler
    CV_IA64_FltS8    =   2068,              // Intel-IA64-Filler
    CV_IA64_FltS9    =   2069,              // Intel-IA64-Filler
    CV_IA64_FltS10   =   2070,              // Intel-IA64-Filler
    CV_IA64_FltS11   =   2071,              // Intel-IA64-Filler
    CV_IA64_FltS12   =   2072,              // Intel-IA64-Filler
    CV_IA64_FltS13   =   2073,              // Intel-IA64-Filler
    CV_IA64_FltS14   =   2074,              // Intel-IA64-Filler
    CV_IA64_FltS15   =   2075,              // Intel-IA64-Filler
    CV_IA64_FltS16   =   2076,              // Intel-IA64-Filler
    CV_IA64_FltS17   =   2077,              // Intel-IA64-Filler
    CV_IA64_FltS18   =   2078,              // Intel-IA64-Filler
    CV_IA64_FltS19   =   2079,              // Intel-IA64-Filler

    // High Floating Point Registers              // Intel-IA64-Filler
    CV_IA64_FltF32   =   2080,              // Intel-IA64-Filler
    CV_IA64_FltF33   =   2081,              // Intel-IA64-Filler
    CV_IA64_FltF34   =   2082,              // Intel-IA64-Filler
    CV_IA64_FltF35   =   2083,              // Intel-IA64-Filler
    CV_IA64_FltF36   =   2084,              // Intel-IA64-Filler
    CV_IA64_FltF37   =   2085,              // Intel-IA64-Filler
    CV_IA64_FltF38   =   2086,              // Intel-IA64-Filler
    CV_IA64_FltF39   =   2087,              // Intel-IA64-Filler
    CV_IA64_FltF40   =   2088,              // Intel-IA64-Filler
    CV_IA64_FltF41   =   2089,              // Intel-IA64-Filler
    CV_IA64_FltF42   =   2090,              // Intel-IA64-Filler
    CV_IA64_FltF43   =   2091,              // Intel-IA64-Filler
    CV_IA64_FltF44   =   2092,              // Intel-IA64-Filler
    CV_IA64_FltF45   =   2093,              // Intel-IA64-Filler
    CV_IA64_FltF46   =   2094,              // Intel-IA64-Filler
    CV_IA64_FltF47   =   2095,              // Intel-IA64-Filler
    CV_IA64_FltF48   =   2096,              // Intel-IA64-Filler
    CV_IA64_FltF49   =   2097,              // Intel-IA64-Filler
    CV_IA64_FltF50   =   2098,              // Intel-IA64-Filler
    CV_IA64_FltF51   =   2099,              // Intel-IA64-Filler
    CV_IA64_FltF52   =   2100,              // Intel-IA64-Filler
    CV_IA64_FltF53   =   2101,              // Intel-IA64-Filler
    CV_IA64_FltF54   =   2102,              // Intel-IA64-Filler
    CV_IA64_FltF55   =   2103,              // Intel-IA64-Filler
    CV_IA64_FltF56   =   2104,              // Intel-IA64-Filler
    CV_IA64_FltF57   =   2105,              // Intel-IA64-Filler
    CV_IA64_FltF58   =   2106,              // Intel-IA64-Filler
    CV_IA64_FltF59   =   2107,              // Intel-IA64-Filler
    CV_IA64_FltF60   =   2108,              // Intel-IA64-Filler
    CV_IA64_FltF61   =   2109,              // Intel-IA64-Filler
    CV_IA64_FltF62   =   2110,              // Intel-IA64-Filler
    CV_IA64_FltF63   =   2111,              // Intel-IA64-Filler
    CV_IA64_FltF64   =   2112,              // Intel-IA64-Filler
    CV_IA64_FltF65   =   2113,              // Intel-IA64-Filler
    CV_IA64_FltF66   =   2114,              // Intel-IA64-Filler
    CV_IA64_FltF67   =   2115,              // Intel-IA64-Filler
    CV_IA64_FltF68   =   2116,              // Intel-IA64-Filler
    CV_IA64_FltF69   =   2117,              // Intel-IA64-Filler
    CV_IA64_FltF70   =   2118,              // Intel-IA64-Filler
    CV_IA64_FltF71   =   2119,              // Intel-IA64-Filler
    CV_IA64_FltF72   =   2120,              // Intel-IA64-Filler
    CV_IA64_FltF73   =   2121,              // Intel-IA64-Filler
    CV_IA64_FltF74   =   2122,              // Intel-IA64-Filler
    CV_IA64_FltF75   =   2123,              // Intel-IA64-Filler
    CV_IA64_FltF76   =   2124,              // Intel-IA64-Filler
    CV_IA64_FltF77   =   2125,              // Intel-IA64-Filler
    CV_IA64_FltF78   =   2126,              // Intel-IA64-Filler
    CV_IA64_FltF79   =   2127,              // Intel-IA64-Filler
    CV_IA64_FltF80   =   2128,              // Intel-IA64-Filler
    CV_IA64_FltF81   =   2129,              // Intel-IA64-Filler
    CV_IA64_FltF82   =   2130,              // Intel-IA64-Filler
    CV_IA64_FltF83   =   2131,              // Intel-IA64-Filler
    CV_IA64_FltF84   =   2132,              // Intel-IA64-Filler
    CV_IA64_FltF85   =   2133,              // Intel-IA64-Filler
    CV_IA64_FltF86   =   2134,              // Intel-IA64-Filler
    CV_IA64_FltF87   =   2135,              // Intel-IA64-Filler
    CV_IA64_FltF88   =   2136,              // Intel-IA64-Filler
    CV_IA64_FltF89   =   2137,              // Intel-IA64-Filler
    CV_IA64_FltF90   =   2138,              // Intel-IA64-Filler
    CV_IA64_FltF91   =   2139,              // Intel-IA64-Filler
    CV_IA64_FltF92   =   2140,              // Intel-IA64-Filler
    CV_IA64_FltF93   =   2141,              // Intel-IA64-Filler
    CV_IA64_FltF94   =   2142,              // Intel-IA64-Filler
    CV_IA64_FltF95   =   2143,              // Intel-IA64-Filler
    CV_IA64_FltF96   =   2144,              // Intel-IA64-Filler
    CV_IA64_FltF97   =   2145,              // Intel-IA64-Filler
    CV_IA64_FltF98   =   2146,              // Intel-IA64-Filler
    CV_IA64_FltF99   =   2147,              // Intel-IA64-Filler
    CV_IA64_FltF100   =   2148,              // Intel-IA64-Filler
    CV_IA64_FltF101   =   2149,              // Intel-IA64-Filler
    CV_IA64_FltF102   =   2150,              // Intel-IA64-Filler
    CV_IA64_FltF103   =   2151,              // Intel-IA64-Filler
    CV_IA64_FltF104   =   2152,              // Intel-IA64-Filler
    CV_IA64_FltF105   =   2153,              // Intel-IA64-Filler
    CV_IA64_FltF106   =   2154,              // Intel-IA64-Filler
    CV_IA64_FltF107   =   2155,              // Intel-IA64-Filler
    CV_IA64_FltF108   =   2156,              // Intel-IA64-Filler
    CV_IA64_FltF109   =   2157,              // Intel-IA64-Filler
    CV_IA64_FltF110   =   2158,              // Intel-IA64-Filler
    CV_IA64_FltF111   =   2159,              // Intel-IA64-Filler
    CV_IA64_FltF112   =   2160,              // Intel-IA64-Filler
    CV_IA64_FltF113   =   2161,              // Intel-IA64-Filler
    CV_IA64_FltF114   =   2162,              // Intel-IA64-Filler
    CV_IA64_FltF115   =   2163,              // Intel-IA64-Filler
    CV_IA64_FltF116   =   2164,              // Intel-IA64-Filler
    CV_IA64_FltF117   =   2165,              // Intel-IA64-Filler
    CV_IA64_FltF118   =   2166,              // Intel-IA64-Filler
    CV_IA64_FltF119   =   2167,              // Intel-IA64-Filler
    CV_IA64_FltF120   =   2168,              // Intel-IA64-Filler
    CV_IA64_FltF121   =   2169,              // Intel-IA64-Filler
    CV_IA64_FltF122   =   2170,              // Intel-IA64-Filler
    CV_IA64_FltF123   =   2171,              // Intel-IA64-Filler
    CV_IA64_FltF124   =   2172,              // Intel-IA64-Filler
    CV_IA64_FltF125   =   2173,              // Intel-IA64-Filler
    CV_IA64_FltF126   =   2174,              // Intel-IA64-Filler
    CV_IA64_FltF127   =   2175,              // Intel-IA64-Filler

    // Application Registers              // Intel-IA64-Filler

    CV_IA64_ApKR0    =   3072,              // Intel-IA64-Filler
    CV_IA64_ApKR1    =   3073,              // Intel-IA64-Filler
    CV_IA64_ApKR2    =   3074,              // Intel-IA64-Filler
    CV_IA64_ApKR3    =   3075,              // Intel-IA64-Filler
    CV_IA64_ApKR4    =   3076,              // Intel-IA64-Filler
    CV_IA64_ApKR5    =   3077,              // Intel-IA64-Filler
    CV_IA64_ApKR6    =   3078,              // Intel-IA64-Filler
    CV_IA64_ApKR7    =   3079,              // Intel-IA64-Filler
    CV_IA64_AR8      =   3080,              // Intel-IA64-Filler
    CV_IA64_AR9      =   3081,              // Intel-IA64-Filler
    CV_IA64_AR10     =   3082,              // Intel-IA64-Filler
    CV_IA64_AR11     =   3083,              // Intel-IA64-Filler
    CV_IA64_AR12     =   3084,              // Intel-IA64-Filler
    CV_IA64_AR13     =   3085,              // Intel-IA64-Filler
    CV_IA64_AR14     =   3086,              // Intel-IA64-Filler
    CV_IA64_AR15     =   3087,              // Intel-IA64-Filler
    CV_IA64_RsRSC    =   3088,              // Intel-IA64-Filler
    CV_IA64_RsBSP    =   3089,              // Intel-IA64-Filler
    CV_IA64_RsBSPSTORE =   3090,              // Intel-IA64-Filler
    CV_IA64_RsRNAT   =   3091,              // Intel-IA64-Filler
    CV_IA64_AR20     =   3092,              // Intel-IA64-Filler
    CV_IA64_AR21     =   3093,              // Intel-IA64-Filler
    CV_IA64_AR22     =   3094,              // Intel-IA64-Filler
    CV_IA64_AR23     =   3095,              // Intel-IA64-Filler
    CV_IA64_AR24     =   3096,              // Intel-IA64-Filler
    CV_IA64_AR25     =   3097,              // Intel-IA64-Filler
    CV_IA64_AR26     =   3098,              // Intel-IA64-Filler
    CV_IA64_AR27     =   3099,              // Intel-IA64-Filler
    CV_IA64_AR28     =   3100,              // Intel-IA64-Filler
    CV_IA64_AR29     =   3101,              // Intel-IA64-Filler
    CV_IA64_AR30     =   3102,              // Intel-IA64-Filler
    CV_IA64_AR31     =   3103,              // Intel-IA64-Filler
    CV_IA64_ApCCV    =   3104,              // Intel-IA64-Filler
    CV_IA64_AR33     =   3105,              // Intel-IA64-Filler
    CV_IA64_AR34     =   3106,              // Intel-IA64-Filler
    CV_IA64_AR35     =   3107,              // Intel-IA64-Filler
    CV_IA64_ApUNAT   =   3108,              // Intel-IA64-Filler
    CV_IA64_AR37     =   3109,              // Intel-IA64-Filler
    CV_IA64_AR38     =   3110,              // Intel-IA64-Filler
    CV_IA64_AR39     =   3111,              // Intel-IA64-Filler
    CV_IA64_StFPSR   =   3112,              // Intel-IA64-Filler
    CV_IA64_AR41     =   3113,              // Intel-IA64-Filler
    CV_IA64_AR42     =   3114,              // Intel-IA64-Filler
    CV_IA64_AR43     =   3115,              // Intel-IA64-Filler
    CV_IA64_ApITC    =   3116,              // Intel-IA64-Filler
    CV_IA64_AR45     =   3117,              // Intel-IA64-Filler
    CV_IA64_AR46     =   3118,              // Intel-IA64-Filler
    CV_IA64_AR47     =   3119,              // Intel-IA64-Filler
    CV_IA64_AR48     =   3120,              // Intel-IA64-Filler
    CV_IA64_AR49     =   3121,              // Intel-IA64-Filler
    CV_IA64_AR50     =   3122,              // Intel-IA64-Filler
    CV_IA64_AR51     =   3123,              // Intel-IA64-Filler
    CV_IA64_AR52     =   3124,              // Intel-IA64-Filler
    CV_IA64_AR53     =   3125,              // Intel-IA64-Filler
    CV_IA64_AR54     =   3126,              // Intel-IA64-Filler
    CV_IA64_AR55     =   3127,              // Intel-IA64-Filler
    CV_IA64_AR56     =   3128,              // Intel-IA64-Filler
    CV_IA64_AR57     =   3129,              // Intel-IA64-Filler
    CV_IA64_AR58     =   3130,              // Intel-IA64-Filler
    CV_IA64_AR59     =   3131,              // Intel-IA64-Filler
    CV_IA64_AR60     =   3132,              // Intel-IA64-Filler
    CV_IA64_AR61     =   3133,              // Intel-IA64-Filler
    CV_IA64_AR62     =   3134,              // Intel-IA64-Filler
    CV_IA64_AR63     =   3135,              // Intel-IA64-Filler
    CV_IA64_RsPFS    =   3136,              // Intel-IA64-Filler
    CV_IA64_ApLC     =   3137,              // Intel-IA64-Filler
    CV_IA64_ApEC     =   3138,              // Intel-IA64-Filler
    CV_IA64_AR67   =   3139,              // Intel-IA64-Filler
    CV_IA64_AR68   =   3140,              // Intel-IA64-Filler
    CV_IA64_AR69   =   3141,              // Intel-IA64-Filler
    CV_IA64_AR70   =   3142,              // Intel-IA64-Filler
    CV_IA64_AR71   =   3143,              // Intel-IA64-Filler
    CV_IA64_AR72   =   3144,              // Intel-IA64-Filler
    CV_IA64_AR73   =   3145,              // Intel-IA64-Filler
    CV_IA64_AR74   =   3146,              // Intel-IA64-Filler
    CV_IA64_AR75   =   3147,              // Intel-IA64-Filler
    CV_IA64_AR76   =   3148,              // Intel-IA64-Filler
    CV_IA64_AR77   =   3149,              // Intel-IA64-Filler
    CV_IA64_AR78   =   3150,              // Intel-IA64-Filler
    CV_IA64_AR79   =   3151,              // Intel-IA64-Filler
    CV_IA64_AR80   =   3152,              // Intel-IA64-Filler
    CV_IA64_AR81   =   3153,              // Intel-IA64-Filler
    CV_IA64_AR82   =   3154,              // Intel-IA64-Filler
    CV_IA64_AR83   =   3155,              // Intel-IA64-Filler
    CV_IA64_AR84   =   3156,              // Intel-IA64-Filler
    CV_IA64_AR85   =   3157,              // Intel-IA64-Filler
    CV_IA64_AR86   =   3158,              // Intel-IA64-Filler
    CV_IA64_AR87   =   3159,              // Intel-IA64-Filler
    CV_IA64_AR88   =   3160,              // Intel-IA64-Filler
    CV_IA64_AR89   =   3161,              // Intel-IA64-Filler
    CV_IA64_AR90   =   3162,              // Intel-IA64-Filler
    CV_IA64_AR91   =   3163,              // Intel-IA64-Filler
    CV_IA64_AR92   =   3164,              // Intel-IA64-Filler
    CV_IA64_AR93   =   3165,              // Intel-IA64-Filler
    CV_IA64_AR94   =   3166,              // Intel-IA64-Filler
    CV_IA64_AR95   =   3167,              // Intel-IA64-Filler
    CV_IA64_AR96   =   3168,              // Intel-IA64-Filler
    CV_IA64_AR97   =   3169,              // Intel-IA64-Filler
    CV_IA64_AR98   =   3170,              // Intel-IA64-Filler
    CV_IA64_AR99   =   3171,              // Intel-IA64-Filler
    CV_IA64_AR100   =   3172,              // Intel-IA64-Filler
    CV_IA64_AR101   =   3173,              // Intel-IA64-Filler
    CV_IA64_AR102   =   3174,              // Intel-IA64-Filler
    CV_IA64_AR103   =   3175,              // Intel-IA64-Filler
    CV_IA64_AR104   =   3176,              // Intel-IA64-Filler
    CV_IA64_AR105   =   3177,              // Intel-IA64-Filler
    CV_IA64_AR106   =   3178,              // Intel-IA64-Filler
    CV_IA64_AR107   =   3179,              // Intel-IA64-Filler
    CV_IA64_AR108   =   3180,              // Intel-IA64-Filler
    CV_IA64_AR109   =   3181,              // Intel-IA64-Filler
    CV_IA64_AR110   =   3182,              // Intel-IA64-Filler
    CV_IA64_AR111   =   3183,              // Intel-IA64-Filler
    CV_IA64_AR112   =   3184,              // Intel-IA64-Filler
    CV_IA64_AR113   =   3185,              // Intel-IA64-Filler
    CV_IA64_AR114   =   3186,              // Intel-IA64-Filler
    CV_IA64_AR115   =   3187,              // Intel-IA64-Filler
    CV_IA64_AR116   =   3188,              // Intel-IA64-Filler
    CV_IA64_AR117   =   3189,              // Intel-IA64-Filler
    CV_IA64_AR118   =   3190,              // Intel-IA64-Filler
    CV_IA64_AR119   =   3191,              // Intel-IA64-Filler
    CV_IA64_AR120   =   3192,              // Intel-IA64-Filler
    CV_IA64_AR121   =   3193,              // Intel-IA64-Filler
    CV_IA64_AR122   =   3194,              // Intel-IA64-Filler
    CV_IA64_AR123   =   3195,              // Intel-IA64-Filler
    CV_IA64_AR124   =   3196,              // Intel-IA64-Filler
    CV_IA64_AR125   =   3197,              // Intel-IA64-Filler
    CV_IA64_AR126   =   3198,              // Intel-IA64-Filler
    CV_IA64_AR127   =   3199,              // Intel-IA64-Filler

    // CPUID Registers                // Intel-IA64-Filler
    CV_IA64_CPUID0  =   3328,              // Intel-IA64-Filler
    CV_IA64_CPUID1  =   3329,              // Intel-IA64-Filler
    CV_IA64_CPUID2  =   3330,              // Intel-IA64-Filler
    CV_IA64_CPUID3  =   3331,              // Intel-IA64-Filler
    CV_IA64_CPUID4  =   3332,              // Intel-IA64-Filler

    // Control Registers              // Intel-IA64-Filler

    CV_IA64_ApDCR    =   4096,              // Intel-IA64-Filler
    CV_IA64_ApITM    =   4097,              // Intel-IA64-Filler
    CV_IA64_ApIVA    =   4098,              // Intel-IA64-Filler
    CV_IA64_CR3      =   4099,              // Intel-IA64-Filler
    CV_IA64_CR4      =   4100,              // Intel-IA64-Filler
    CV_IA64_CR5      =   4101,              // Intel-IA64-Filler
    CV_IA64_CR6      =   4102,              // Intel-IA64-Filler
    CV_IA64_CR7      =   4103,              // Intel-IA64-Filler
    CV_IA64_ApPTA    =   4104,              // Intel-IA64-Filler
    CV_IA64_ApGPTA   =   4105,              // Intel-IA64-Filler
    CV_IA64_CR10     =   4106,              // Intel-IA64-Filler
    CV_IA64_CR11     =   4107,              // Intel-IA64-Filler
    CV_IA64_CR12     =   4108,              // Intel-IA64-Filler
    CV_IA64_CR13     =   4109,              // Intel-IA64-Filler
    CV_IA64_CR14     =   4110,              // Intel-IA64-Filler
    CV_IA64_CR15     =   4111,              // Intel-IA64-Filler
    CV_IA64_StIPSR   =   4112,              // Intel-IA64-Filler
    CV_IA64_StISR    =   4113,              // Intel-IA64-Filler
    CV_IA64_CR18     =   4114,              // Intel-IA64-Filler
    CV_IA64_StIIP    =   4115,              // Intel-IA64-Filler
    CV_IA64_StIFA    =   4116,              // Intel-IA64-Filler
    CV_IA64_StITIR   =   4117,              // Intel-IA64-Filler
    CV_IA64_StIIPA   =   4118,              // Intel-IA64-Filler
    CV_IA64_StIFS    =   4119,              // Intel-IA64-Filler
    CV_IA64_StIIM    =   4120,              // Intel-IA64-Filler
    CV_IA64_StIHA    =   4121,              // Intel-IA64-Filler
    CV_IA64_CR26     =   4122,              // Intel-IA64-Filler
    CV_IA64_CR27     =   4123,              // Intel-IA64-Filler
    CV_IA64_CR28     =   4124,              // Intel-IA64-Filler
    CV_IA64_CR29     =   4125,              // Intel-IA64-Filler
    CV_IA64_CR30     =   4126,              // Intel-IA64-Filler
    CV_IA64_CR31     =   4127,              // Intel-IA64-Filler
    CV_IA64_CR32     =   4128,              // Intel-IA64-Filler
    CV_IA64_CR33     =   4129,              // Intel-IA64-Filler
    CV_IA64_CR34     =   4130,              // Intel-IA64-Filler
    CV_IA64_CR35     =   4131,              // Intel-IA64-Filler
    CV_IA64_CR36     =   4132,              // Intel-IA64-Filler
    CV_IA64_CR37     =   4133,              // Intel-IA64-Filler
    CV_IA64_CR38     =   4134,              // Intel-IA64-Filler
    CV_IA64_CR39     =   4135,              // Intel-IA64-Filler
    CV_IA64_CR40     =   4136,              // Intel-IA64-Filler
    CV_IA64_CR41     =   4137,              // Intel-IA64-Filler
    CV_IA64_CR42     =   4138,              // Intel-IA64-Filler
    CV_IA64_CR43     =   4139,              // Intel-IA64-Filler
    CV_IA64_CR44     =   4140,              // Intel-IA64-Filler
    CV_IA64_CR45     =   4141,              // Intel-IA64-Filler
    CV_IA64_CR46     =   4142,              // Intel-IA64-Filler
    CV_IA64_CR47     =   4143,              // Intel-IA64-Filler
    CV_IA64_CR48     =   4144,              // Intel-IA64-Filler
    CV_IA64_CR49     =   4145,              // Intel-IA64-Filler
    CV_IA64_CR50     =   4146,              // Intel-IA64-Filler
    CV_IA64_CR51     =   4147,              // Intel-IA64-Filler
    CV_IA64_CR52     =   4148,              // Intel-IA64-Filler
    CV_IA64_CR53     =   4149,              // Intel-IA64-Filler
    CV_IA64_CR54     =   4150,              // Intel-IA64-Filler
    CV_IA64_CR55     =   4151,              // Intel-IA64-Filler
    CV_IA64_CR56     =   4152,              // Intel-IA64-Filler
    CV_IA64_CR57     =   4153,              // Intel-IA64-Filler
    CV_IA64_CR58     =   4154,              // Intel-IA64-Filler
    CV_IA64_CR59     =   4155,              // Intel-IA64-Filler
    CV_IA64_CR60     =   4156,              // Intel-IA64-Filler
    CV_IA64_CR61     =   4157,              // Intel-IA64-Filler
    CV_IA64_CR62     =   4158,              // Intel-IA64-Filler
    CV_IA64_CR63     =   4159,              // Intel-IA64-Filler
    CV_IA64_SaLID    =   4160,              // Intel-IA64-Filler
    CV_IA64_SaIVR    =   4161,              // Intel-IA64-Filler
    CV_IA64_SaTPR    =   4162,              // Intel-IA64-Filler
    CV_IA64_SaEOI    =   4163,              // Intel-IA64-Filler
    CV_IA64_SaIRR0   =   4164,              // Intel-IA64-Filler
    CV_IA64_SaIRR1   =   4165,              // Intel-IA64-Filler
    CV_IA64_SaIRR2   =   4166,              // Intel-IA64-Filler
    CV_IA64_SaIIR3   =   4167,              // Intel-IA64-Filler
    CV_IA64_SaITV    =   4168,              // Intel-IA64-Filler
    CV_IA64_SaPMV    =   4169,              // Intel-IA64-Filler
    CV_IA64_SaCMCV   =   4170,              // Intel-IA64-Filler
    CV_IA64_CR75     =   4171,              // Intel-IA64-Filler
    CV_IA64_CR76     =   4172,              // Intel-IA64-Filler
    CV_IA64_CR77     =   4173,              // Intel-IA64-Filler
    CV_IA64_CR78     =   4174,              // Intel-IA64-Filler
    CV_IA64_CR79     =   4175,              // Intel-IA64-Filler
    CV_IA64_SaLRR0   =   4176,              // Intel-IA64-Filler
    CV_IA64_SaLRR1   =   4177,              // Intel-IA64-Filler
    CV_IA64_CR82     =   4178,              // Intel-IA64-Filler
    CV_IA64_CR83     =   4179,              // Intel-IA64-Filler
    CV_IA64_CR84     =   4180,              // Intel-IA64-Filler
    CV_IA64_CR85     =   4181,              // Intel-IA64-Filler
    CV_IA64_CR86     =   4182,              // Intel-IA64-Filler
    CV_IA64_CR87     =   4183,              // Intel-IA64-Filler
    CV_IA64_CR88     =   4184,              // Intel-IA64-Filler
    CV_IA64_CR89     =   4185,              // Intel-IA64-Filler
    CV_IA64_CR90     =   4186,              // Intel-IA64-Filler
    CV_IA64_CR91     =   4187,              // Intel-IA64-Filler
    CV_IA64_CR92     =   4188,              // Intel-IA64-Filler
    CV_IA64_CR93     =   4189,              // Intel-IA64-Filler
    CV_IA64_CR94     =   4190,              // Intel-IA64-Filler
    CV_IA64_CR95     =   4191,              // Intel-IA64-Filler
    CV_IA64_CR96     =   4192,              // Intel-IA64-Filler
    CV_IA64_CR97     =   4193,              // Intel-IA64-Filler
    CV_IA64_CR98     =   4194,              // Intel-IA64-Filler
    CV_IA64_CR99     =   4195,              // Intel-IA64-Filler
    CV_IA64_CR100    =   4196,              // Intel-IA64-Filler
    CV_IA64_CR101    =   4197,              // Intel-IA64-Filler
    CV_IA64_CR102    =   4198,              // Intel-IA64-Filler
    CV_IA64_CR103    =   4199,              // Intel-IA64-Filler
    CV_IA64_CR104    =   4200,              // Intel-IA64-Filler
    CV_IA64_CR105    =   4201,              // Intel-IA64-Filler
    CV_IA64_CR106    =   4202,              // Intel-IA64-Filler
    CV_IA64_CR107    =   4203,              // Intel-IA64-Filler
    CV_IA64_CR108    =   4204,              // Intel-IA64-Filler
    CV_IA64_CR109    =   4205,              // Intel-IA64-Filler
    CV_IA64_CR110    =   4206,              // Intel-IA64-Filler
    CV_IA64_CR111    =   4207,              // Intel-IA64-Filler
    CV_IA64_CR112    =   4208,              // Intel-IA64-Filler
    CV_IA64_CR113    =   4209,              // Intel-IA64-Filler
    CV_IA64_CR114    =   4210,              // Intel-IA64-Filler
    CV_IA64_CR115    =   4211,              // Intel-IA64-Filler
    CV_IA64_CR116    =   4212,              // Intel-IA64-Filler
    CV_IA64_CR117    =   4213,              // Intel-IA64-Filler
    CV_IA64_CR118    =   4214,              // Intel-IA64-Filler
    CV_IA64_CR119    =   4215,              // Intel-IA64-Filler
    CV_IA64_CR120    =   4216,              // Intel-IA64-Filler
    CV_IA64_CR121    =   4217,              // Intel-IA64-Filler
    CV_IA64_CR122    =   4218,              // Intel-IA64-Filler
    CV_IA64_CR123    =   4219,              // Intel-IA64-Filler
    CV_IA64_CR124    =   4220,              // Intel-IA64-Filler
    CV_IA64_CR125    =   4221,              // Intel-IA64-Filler
    CV_IA64_CR126    =   4222,              // Intel-IA64-Filler
    CV_IA64_CR127    =   4223,              // Intel-IA64-Filler

    // Protection Key Registers              // Intel-IA64-Filler

    CV_IA64_Pkr0     =   5120,              // Intel-IA64-Filler
    CV_IA64_Pkr1     =   5121,              // Intel-IA64-Filler
    CV_IA64_Pkr2     =   5122,              // Intel-IA64-Filler
    CV_IA64_Pkr3     =   5123,              // Intel-IA64-Filler
    CV_IA64_Pkr4     =   5124,              // Intel-IA64-Filler
    CV_IA64_Pkr5     =   5125,              // Intel-IA64-Filler
    CV_IA64_Pkr6     =   5126,              // Intel-IA64-Filler
    CV_IA64_Pkr7     =   5127,              // Intel-IA64-Filler
    CV_IA64_Pkr8     =   5128,              // Intel-IA64-Filler
    CV_IA64_Pkr9     =   5129,              // Intel-IA64-Filler
    CV_IA64_Pkr10    =   5130,              // Intel-IA64-Filler
    CV_IA64_Pkr11    =   5131,              // Intel-IA64-Filler
    CV_IA64_Pkr12    =   5132,              // Intel-IA64-Filler
    CV_IA64_Pkr13    =   5133,              // Intel-IA64-Filler
    CV_IA64_Pkr14    =   5134,              // Intel-IA64-Filler
    CV_IA64_Pkr15    =   5135,              // Intel-IA64-Filler

    // Region Registers

    CV_IA64_Rr0      =   6144,              // Intel-IA64-Filler
    CV_IA64_Rr1      =   6145,              // Intel-IA64-Filler
    CV_IA64_Rr2      =   6146,              // Intel-IA64-Filler
    CV_IA64_Rr3      =   6147,              // Intel-IA64-Filler
    CV_IA64_Rr4      =   6148,              // Intel-IA64-Filler
    CV_IA64_Rr5      =   6149,              // Intel-IA64-Filler
    CV_IA64_Rr6      =   6150,              // Intel-IA64-Filler
    CV_IA64_Rr7      =   6151,              // Intel-IA64-Filler

    // Performance Monitor Data Registers              // Intel-IA64-Filler

    CV_IA64_PFD0     =   7168,              // Intel-IA64-Filler
    CV_IA64_PFD1     =   7169,              // Intel-IA64-Filler
    CV_IA64_PFD2     =   7170,              // Intel-IA64-Filler
    CV_IA64_PFD3     =   7171,              // Intel-IA64-Filler
    CV_IA64_PFD4     =   7172,              // Intel-IA64-Filler
    CV_IA64_PFD5     =   7173,              // Intel-IA64-Filler
    CV_IA64_PFD6     =   7174,              // Intel-IA64-Filler
    CV_IA64_PFD7     =   7175,              // Intel-IA64-Filler

    // Performance Monitor Config Registers              // Intel-IA64-Filler

    CV_IA64_PFC0     =   7424,              // Intel-IA64-Filler
    CV_IA64_PFC1     =   7425,              // Intel-IA64-Filler
    CV_IA64_PFC2     =   7426,              // Intel-IA64-Filler
    CV_IA64_PFC3     =   7427,              // Intel-IA64-Filler
    CV_IA64_PFC4     =   7428,              // Intel-IA64-Filler
    CV_IA64_PFC5     =   7429,              // Intel-IA64-Filler
    CV_IA64_PFC6     =   7430,              // Intel-IA64-Filler
    CV_IA64_PFC7     =   7431,              // Intel-IA64-Filler

    // Instruction Translation Registers              // Intel-IA64-Filler

    CV_IA64_TrI0     =   8192,              // Intel-IA64-Filler
    CV_IA64_TrI1     =   8193,              // Intel-IA64-Filler
    CV_IA64_TrI2     =   8194,              // Intel-IA64-Filler
    CV_IA64_TrI3     =   8195,              // Intel-IA64-Filler
    CV_IA64_TrI4     =   8196,              // Intel-IA64-Filler
    CV_IA64_TrI5     =   8197,              // Intel-IA64-Filler
    CV_IA64_TrI6     =   8198,              // Intel-IA64-Filler
    CV_IA64_TrI7     =   8199,              // Intel-IA64-Filler

    // Data Translation Registers              // Intel-IA64-Filler

    CV_IA64_TrD0     =   8320,              // Intel-IA64-Filler
    CV_IA64_TrD1     =   8321,              // Intel-IA64-Filler
    CV_IA64_TrD2     =   8322,              // Intel-IA64-Filler
    CV_IA64_TrD3     =   8323,              // Intel-IA64-Filler
    CV_IA64_TrD4     =   8324,              // Intel-IA64-Filler
    CV_IA64_TrD5     =   8325,              // Intel-IA64-Filler
    CV_IA64_TrD6     =   8326,              // Intel-IA64-Filler
    CV_IA64_TrD7     =   8327,              // Intel-IA64-Filler

    // Instruction Breakpoint Registers              // Intel-IA64-Filler

    CV_IA64_DbI0     =   8448,              // Intel-IA64-Filler
    CV_IA64_DbI1     =   8449,              // Intel-IA64-Filler
    CV_IA64_DbI2     =   8450,              // Intel-IA64-Filler
    CV_IA64_DbI3     =   8451,              // Intel-IA64-Filler
    CV_IA64_DbI4     =   8452,              // Intel-IA64-Filler
    CV_IA64_DbI5     =   8453,              // Intel-IA64-Filler
    CV_IA64_DbI6     =   8454,              // Intel-IA64-Filler
    CV_IA64_DbI7     =   8455,              // Intel-IA64-Filler

    // Data Breakpoint Registers              // Intel-IA64-Filler

    CV_IA64_DbD0     =   8576,              // Intel-IA64-Filler
    CV_IA64_DbD1     =   8577,              // Intel-IA64-Filler
    CV_IA64_DbD2     =   8578,              // Intel-IA64-Filler
    CV_IA64_DbD3     =   8579,              // Intel-IA64-Filler
    CV_IA64_DbD4     =   8580,              // Intel-IA64-Filler
    CV_IA64_DbD5     =   8581,              // Intel-IA64-Filler
    CV_IA64_DbD6     =   8582,              // Intel-IA64-Filler
    CV_IA64_DbD7     =   8583,              // Intel-IA64-Filler

} IA64_REG_INDEX;              // Intel-IA64-Filler


#endif // _IA64REG_

